## cbmc 5.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
    message(STATUS "Rule launch compile: ${CCACHE_PROGRAM}")
 endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS true)

set(CMAKE_OSX_DEPLOYMENT_TARGET 10.9)

include(GNUInstallDirs)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
   "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU"
)
    #   Ensure NDEBUG is not set for release builds
    set(CMAKE_CXX_FLAGS_RELEASE "-O2")
    #   Enable lots of warnings
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wpedantic -Werror -Wno-deprecated-declarations")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    #   This would be the place to enable warnings for Windows builds, although
    #   config.inc doesn't seem to do that currently
endif()

set(enable_cbmc_tests on CACHE BOOL "Whether CBMC tests should be enabled")

set(sat_impl "minisat2" CACHE STRING
    "This setting controls the SAT library which is used. Valid values are 'minisat2' and 'glucose'"
)

if(${enable_cbmc_tests})
    enable_testing()
endif()

file(STRINGS src/config.inc config_inc_v REGEX "CBMC_VERSION *= *[0-9\.]+")
string(REGEX REPLACE "^CBMC_VERSION *= *" "" CBMC_RELEASE ${config_inc_v})
message(STATUS "CBMC release ${CBMC_RELEASE}")

find_package(Git)

macro(git_revision target files_var)
  if(GIT_FOUND)
    add_custom_command(
      OUTPUT .release_info
      COMMAND ${CMAKE_COMMAND} -E echo_append "#define __CBMC_VERSION " > .release_info
      COMMAND "${GIT_EXECUTABLE}" "describe" "--tags" "--always" "--long" >> .release_info
      COMMAND ${CMAKE_COMMAND} -E echo "#define __CBMC_VERSION_str(v) \"${CBMC_RELEASE} (\" # v \")\"" >> .release_info
      COMMAND ${CMAKE_COMMAND} -E echo "#define __CBMC_VERSION_xstr(v) __CBMC_VERSION_str(v)" >> .release_info
      COMMAND ${CMAKE_COMMAND} -E echo "#define CBMC_VERSION __CBMC_VERSION_xstr(__CBMC_VERSION)" >> .release_info
      VERBATIM
      )
    add_custom_command(
      TARGET ${target}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E remove -f .release_info
      )
  else()
    add_custom_command(
      OUTPUT .release_info
      COMMAND ${CMAKE_COMMAND} -E echo "#define CBMC_VERSION \"${CBMC_RELEASE} (n/a)\"" >> .release_info
      VERBATIM
      )
  endif()

  if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
     "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU"
  )
    set_source_files_properties(
      ${${files_var}}
      PROPERTIES
        OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/.release_info
        COMPILE_FLAGS "-include .release_info")
  elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    set_source_files_properties(
      ${${files_var}}
      PROPERTIES
        COMPILE_FLAGS "/DCBMC_VERSION=\"${CBMC_RELEASE} (n/a)\"")
  endif()
endmacro()

add_subdirectory(src)
add_subdirectory(regression)
add_subdirectory(unit)

add_subdirectory(jbmc)

set_target_properties(
    analyses
    ansi-c
    assembler
    big-int
    cbmc
    cbmc-lib
    clobber
    clobber-lib
    cpp
    driver
    goto-analyzer
    goto-analyzer-lib
    goto-cc
    goto-cc-lib
    goto-diff
    goto-diff-lib
    goto-instrument
    goto-instrument-lib
    goto-programs
    goto-symex
    jsil
    json
    langapi
    linking
    miniBDD
    mmcc
    pointer-analysis
    solvers
    test-bigint
    testing-utils
    unit
    util
    xml

    java_bytecode
    jbmc
    jbmc-lib
    janalyzer
    janalyzer-lib
    jdiff
    jdiff-lib
    java-testing-utils
    java-unit
    miniz

    PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED true
    XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "Developer ID Application: Daniel Kroening"
)

=== jbmc/CMakeLists.txt ===
add_subdirectory(regression)
add_subdirectory(src)
add_subdirectory(unit)

=== unit/CMakeLists.txt ===
file(GLOB_RECURSE sources "*.cpp" "*.h")

file(GLOB_RECURSE testing_utils "testing-utils/*.cpp" "testing-utils/*.h")

list(REMOVE_ITEM sources
    # Used in executables
    ${CMAKE_CURRENT_SOURCE_DIR}/miniBDD.cpp

    # Don't build
    ${CMAKE_CURRENT_SOURCE_DIR}/sharing_map.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/elf_reader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/smt2_parser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/json.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/cpp_parser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/osx_fat_reader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/unicode.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/wp.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/cpp_scanner.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/float_utils.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ieee_float.cpp

    # Will be built into a separate library and linked
    ${testing_utils}

    # Intended to fail to compile
    ${CMAKE_CURRENT_SOURCE_DIR}/util/expr_cast/expr_undefined_casts.cpp
)

add_subdirectory(testing-utils)

add_executable(unit ${sources})
target_include_directories(unit
    PUBLIC
    ${CBMC_BINARY_DIR}
    ${CBMC_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
)
target_link_libraries(
        unit
        testing-utils
        ansi-c
        solvers
        goto-programs
        goto-instrument-lib
        cbmc-lib
)

add_test(
    NAME unit
    COMMAND $<TARGET_FILE:unit>
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)
set_tests_properties(unit PROPERTIES LABELS "CORE;CBMC")

add_executable(miniBDD miniBDD.cpp)
target_include_directories(miniBDD
    PUBLIC
    ${CBMC_BINARY_DIR}
    ${CBMC_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
)
target_link_libraries(miniBDD solvers ansi-c)
add_test(NAME miniBDD COMMAND $<TARGET_FILE:miniBDD>)
set_tests_properties(miniBDD PROPERTIES LABELS "CORE;CBMC")

=== unit/Makefile ===
.PHONY: all cprover.dir testing-utils.dir test

# Source files for test utilities
SRC = unit_tests.cpp \
      catch_example.cpp \
      # Empty last line

# Test source files
SRC += unit_tests.cpp \
       analyses/ai/ai_simplify_lhs.cpp \
       analyses/call_graph.cpp \
       analyses/does_remove_const/does_expr_lose_const.cpp \
       analyses/does_remove_const/does_type_preserve_const_correctness.cpp \
       analyses/does_remove_const/is_type_at_least_as_const_as.cpp \
       goto-programs/goto_trace_output.cpp \
       path_strategies.cpp \
       solvers/refinement/array_pool/array_pool.cpp \
       solvers/refinement/string_constraint_generator_valueof/calculate_max_string_length.cpp \
       solvers/refinement/string_constraint_generator_valueof/get_numeric_value_from_character.cpp \
       solvers/refinement/string_constraint_generator_valueof/is_digit_with_radix.cpp \
       solvers/refinement/string_refinement/concretize_array.cpp \
       solvers/refinement/string_refinement/substitute_array_list.cpp \
       solvers/refinement/string_refinement/sparse_array.cpp \
       solvers/refinement/string_refinement/union_find_replace.cpp \
       util/expr_cast/expr_cast.cpp \
       util/irep.cpp \
       util/irep_sharing.cpp \
       util/message.cpp \
       util/optional.cpp \
       util/sharing_node.cpp \
       util/sharing_map.cpp \
       util/small_map.cpp \
       util/small_shared_two_way_ptr.cpp \
       util/string_utils/split_string.cpp \
       util/string_utils/strip_string.cpp \
       util/symbol_table.cpp \
       catch_example.cpp \
       # Empty last line

INCLUDES= -I ../src/ -I.

include ../src/config.inc
include ../src/common

cprover.dir:
	$(MAKE) $(MAKEARGS) -C ../src

testing-utils.dir:
	$(MAKE) $(MAKEARGS) -C testing-utils

# We need to link bmc.o to the unit test, so here's everything it depends on...
BMC_DEPS =../src/cbmc/all_properties$(OBJEXT) \
          ../src/cbmc/bmc$(OBJEXT) \
          ../src/cbmc/bmc_cover$(OBJEXT) \
          ../src/cbmc/bv_cbmc$(OBJEXT) \
          ../src/cbmc/cbmc_dimacs$(OBJEXT) \
          ../src/cbmc/cbmc_languages$(OBJEXT) \
          ../src/cbmc/cbmc_parse_options$(OBJEXT) \
          ../src/cbmc/cbmc_solvers$(OBJEXT) \
          ../src/cbmc/counterexample_beautification$(OBJEXT) \
          ../src/cbmc/fault_localization$(OBJEXT) \
          ../src/cbmc/show_vcc$(OBJEXT) \
          ../src/cbmc/symex_bmc$(OBJEXT) \
          ../src/cbmc/symex_coverage$(OBJEXT) \
          ../src/cbmc/xml_interface$(OBJEXT) \
          ../src/xmllang/xmllang$(LIBEXT) \
          ../src/goto-symex/goto-symex$(LIBEXT) \
          ../src/jsil/jsil$(LIBEXT) \
          # Empty last line
#
CPROVER_LIBS =../src/ansi-c/ansi-c$(LIBEXT) \
              ../src/cpp/cpp$(LIBEXT) \
              ../src/json/json$(LIBEXT) \
              ../src/linking/linking$(LIBEXT) \
              ../src/util/util$(LIBEXT) \
              ../src/big-int/big-int$(LIBEXT) \
              ../src/goto-programs/goto-programs$(LIBEXT) \
              ../src/goto-instrument/goto-instrument$(LIBEXT) \
              ../src/pointer-analysis/pointer-analysis$(LIBEXT) \
              ../src/langapi/langapi$(LIBEXT) \
              ../src/assembler/assembler$(LIBEXT) \
              ../src/analyses/analyses$(LIBEXT) \
              ../src/solvers/solvers$(LIBEXT) \
              $(BMC_DEPS)
              # Empty last line

OBJ += $(CPROVER_LIBS) testing-utils/testing-utils$(LIBEXT)

TESTS = unit_tests$(EXEEXT) \
        miniBDD$(EXEEXT) \
        # Empty last line

CLEANFILES = $(TESTS)

all: cprover.dir testing-utils.dir
	$(MAKE) $(MAKEARGS) $(TESTS)

test: all
	$(foreach test,$(TESTS), (echo Running: $(test); ./$(test)) &&) true


###############################################################################

unit_tests$(EXEEXT): $(OBJ)
	$(LINKBIN)

miniBDD$(EXEEXT): miniBDD$(OBJEXT) $(CPROVER_LIBS)
	$(LINKBIN)

=== jbmc/regression/CMakeLists.txt ===
set(test_pl_path "${CBMC_SOURCE_DIR}/../regression/test.pl")

# For the best possible utilisation of multiple cores when
# running tests in parallel, it is important that these directories are
# listed with decreasing runtimes (i.e. longest running at the top)
add_subdirectory(jbmc)
add_subdirectory(strings-smoke-tests)
add_subdirectory(jbmc-strings)
add_subdirectory(jdiff)
add_subdirectory(janalyzer-taint)
add_subdirectory(jbmc-concurrency)
add_subdirectory(jbmc-inheritance)
add_subdirectory(jbmc-cover)

=== jbmc/regression/Makefile ===
# For the best possible utilisation of multiple cores when
# running tests in parallel, it is important that these directories are
# listed with decreasing runtimes (i.e. longest running at the top)
DIRS = janalzyer-taint \
       jbmc \
       jbmc-concurrency \
       jbmc-cover \
       jbmc-inheritance \
       jbmc-strings \
       jdiff \
       string-smoke-tests \
       # Empty last line

# Tests under goto-gcc cannot be run on Windows, so appveyor.yml unlinks
# the entire directory under Windows. This variable will contain the list
# of directories that actually exist on the current platform.
PLATFORM_DIRS = $(wildcard $(DIRS))

# Run all test directories in sequence
.PHONY: test
test:
	@for dir in $(PLATFORM_DIRS); do \
		$(MAKE) "$$dir" || exit 1; \
	done;

# Pattern to execute a single test suite directory
.PHONY: $(PLATFORM_DIRS)
$(PLATFORM_DIRS):
	@echo "Running $@..." ;
	$(MAKE) -C "$@" test || exit 1;

# Run all test directories using GNU Parallel
.PHONY: test-parallel
.NOTPARALLEL: test-parallel
test-parallel:
	@echo "Building with $(JOBS) jobs"
	parallel \
		--halt soon,fail=1 \
		--tag \
		--tagstring '{#}:' \
		--linebuffer \
		--jobs $(JOBS) \
		$(MAKE) "{}" \
		::: $(PLATFORM_DIRS)


.PHONY: clean
clean:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			$(MAKE) -C "$$dir" clean; \
		fi; \
	done;

=== jbmc/src/Makefile ===
DIRS = janalyzer jbmc jdiff java_bytecode miniz
ROOT = ../

include config.inc

.PHONY: all
all: janalyzer.dir jbmc.dir jdiff.dir

# building cbmc proper
.PHONY: cprover.dir
cprover.dir:
	$(MAKE) $(MAKEARGS) -C $(CPROVER_DIR)/src

.PHONY: java_bytecode.dir
java_bytecode.dir: miniz.dir

.PHONY: janalyzer.dir
janalyzer.dir: java_bytecode.dir cprover.dir

.PHONY: jbmc.dir
jbmc.dir: java_bytecode.dir cprover.dir

.PHONY: jdiff.dir
jdiff.dir: java_bytecode.dir cprover.dir

.PHONY: miniz.dir
miniz.dir:

$(patsubst %, %.dir, $(DIRS)):
	## Entering $(basename $@)
	$(MAKE) $(MAKEARGS) -C $(basename $@)

# generate source files

$(patsubst %, %_generated_files, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_generated_files, %, $@) generated_files

.PHONY: generated_files
generated_files: $(patsubst %, %_generated_files, $(DIRS))

# cleaning

.PHONY: clean
clean: $(patsubst %, %_clean, $(DIRS)) cprover_clean dist_clean

$(patsubst %, %_clean, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_clean, %, $@) clean ; \

.PHONY: cprover_clean
cprover_clean:
	$(MAKE) $(MAKEARGS) -C $(CPROVER_DIR)/src clean

.PHONY: dist_clean
dist_clean:
	rm -rf $(ROOT)dist

# extended JBMC models download, for your convenience
java-models-library-download:
	@echo "Downloading java models library"
	@wget https://github.com/diffblue/java-models-library/archive/master.zip -O java-models-library.zip
	@unzip java-models-library.zip
	@rm java-models-library.zip
	@cp -r java-models-library-master/src java_bytecode/library
	@rm -r java-models-library-master

.PHONY: dist
dist: java-models-library-download all
	mkdir -p $(ROOT)dist/lib
	cp java_bytecode/library/core-models.jar $(ROOT)dist/lib
	mkdir -p $(ROOT)dist/bin
	cp jbmc/jbmc $(ROOT)dist/bin
	cp janalyzer/janalyzer $(ROOT)dist/bin
	cp jdiff/jdiff $(ROOT)dist/bin

=== jbmc/unit/CMakeLists.txt ===
file(GLOB_RECURSE sources "*.cpp" "*.h")
list(APPEND sources  ${CBMC_SOURCE_DIR}/../unit/unit_tests.cpp)

file(GLOB_RECURSE java-testing_utils "java-testing-utils/*.cpp" "java-testing-utils/*.h")

list(REMOVE_ITEM sources
    # Don't build
    ${CMAKE_CURRENT_SOURCE_DIR}/sharing_map.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/elf_reader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/smt2_parser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/json.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/cpp_parser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/osx_fat_reader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/unicode.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/wp.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/cpp_scanner.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/float_utils.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ieee_float.cpp

    # Will be built into a separate library and linked
    ${java-testing_utils}

    # Intended to fail to compile
    ${CMAKE_CURRENT_SOURCE_DIR}/util/expr_cast/expr_undefined_casts.cpp
)

add_subdirectory(java-testing-utils)

add_executable(java-unit ${sources})
target_include_directories(java-unit
    PUBLIC
    ${CBMC_BINARY_DIR}
    ${CBMC_SOURCE_DIR}
    ${CBMC_SOURCE_DIR}/../unit
    ${CMAKE_CURRENT_SOURCE_DIR}
)
target_link_libraries(java-unit
        java-testing-utils
        testing-utils
        ansi-c
        solvers
        goto-programs
        goto-instrument-lib
        cbmc-lib
)

add_test(
    NAME java-unit
    COMMAND $<TARGET_FILE:java-unit>
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)
set_tests_properties(java-unit PROPERTIES LABELS "CORE;CBMC")

=== jbmc/unit/Makefile ===
.PHONY: all cprover.dir jprover.dir testing-utils.dir java-testing-utils.dir test

# Source files for test utilities
SRC = $(CPROVER_DIR)/unit/unit_tests.cpp \
      # Empty last line

# Test source files
SRC += java_bytecode/goto-programs/class_hierarchy_output.cpp \
       java_bytecode/goto-programs/class_hierarchy_graph.cpp \
       java_bytecode/goto-programs/remove_virtual_functions_without_fallback.cpp \
       java_bytecode/java_bytecode_convert_class/convert_abstract_class.cpp \
       java_bytecode/java_bytecode_convert_class/convert_java_annotations.cpp \
       java_bytecode/java_bytecode_convert_method/convert_invoke_dynamic.cpp \
       java_bytecode/java_bytecode_parse_generics/parse_generic_class.cpp \
       java_bytecode/java_object_factory/gen_nondet_string_init.cpp \
       java_bytecode/java_bytecode_parse_lambdas/java_bytecode_parse_lambda_method_table.cpp \
       java_bytecode/java_bytecode_parse_lambdas/java_bytecode_convert_class_lambda_method_handles.cpp \
       java_bytecode/java_string_library_preprocess/convert_exprt_to_string_exprt.cpp \
       java_bytecode/java_types/erase_type_arguments.cpp \
       java_bytecode/java_types/generic_type_index.cpp \
       java_bytecode/java_types/java_generic_symbol_type.cpp \
       java_bytecode/java_types/java_type_from_string.cpp \
       java_bytecode/java_utils_test.cpp \
       java_bytecode/inherited_static_fields/inherited_static_fields.cpp \
       pointer-analysis/custom_value_set_analysis.cpp \
       solvers/refinement/string_constraint_instantiation/instantiate_not_contains.cpp \
       solvers/refinement/string_refinement/dependency_graph.cpp \
       solvers/refinement/string_refinement/string_symbol_resolution.cpp \
       util/expr_iterator.cpp \
       util/has_subtype.cpp \
       util/parameter_indices.cpp \
       util/simplify_expr.cpp \
       java_bytecode/java_virtual_functions/virtual_functions.cpp \
       java_bytecode/java_bytecode_parse_generics/parse_generic_superclasses.cpp \
       java_bytecode/goto_program_generics/mutually_recursive_generics.cpp \
       # Empty last line

INCLUDES= -I ../src/ -I. -I $(CPROVER_DIR)/src -I $(CPROVER_DIR)/unit

include ../src/config.inc
include $(CPROVER_DIR)/src/config.inc
include $(CPROVER_DIR)/src/common

cprover.dir:
	$(MAKE) $(MAKEARGS) -C $(CPROVER_DIR)/src

jprover.dir:
	$(MAKE) $(MAKEARGS) -C ../src

cprover-testing-utils.dir:
	$(MAKE) $(MAKEARGS) -C $(CPROVER_DIR)/unit/testing-utils

java-testing-utils.dir:
	$(MAKE) $(MAKEARGS) -C java-testing-utils

# We need to link bmc.o to the unit test, so here's everything it depends on...
BMC_DEPS =$(CPROVER_DIR)/src/cbmc/all_properties$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/bmc$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/bmc_cover$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/bv_cbmc$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/cbmc_dimacs$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/cbmc_languages$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/cbmc_parse_options$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/cbmc_solvers$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/counterexample_beautification$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/fault_localization$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/show_vcc$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/symex_bmc$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/symex_coverage$(OBJEXT) \
          $(CPROVER_DIR)/src/cbmc/xml_interface$(OBJEXT) \
          $(CPROVER_DIR)/src/jsil/expr2jsil$(OBJEXT) \
          $(CPROVER_DIR)/src/jsil/jsil_convert$(OBJEXT) \
          $(CPROVER_DIR)/src/jsil/jsil_entry_point$(OBJEXT) \
          $(CPROVER_DIR)/src/jsil/jsil_internal_additions$(OBJEXT) \
          $(CPROVER_DIR)/src/jsil/jsil_language$(OBJEXT) \
          $(CPROVER_DIR)/src/jsil/jsil_lex.yy$(OBJEXT) \
          $(CPROVER_DIR)/src/jsil/jsil_parser$(OBJEXT) \
          $(CPROVER_DIR)/src/jsil/jsil_parse_tree$(OBJEXT) \
          $(CPROVER_DIR)/src/jsil/jsil_typecheck$(OBJEXT) \
          $(CPROVER_DIR)/src/jsil/jsil_types$(OBJEXT) \
          $(CPROVER_DIR)/src/jsil/jsil_y.tab$(OBJEXT) \
          # Empty last line

CPROVER_LIBS =../src/java_bytecode/java_bytecode$(LIBEXT) \
              ../src/miniz/miniz$(OBJEXT) \
              $(CPROVER_DIR)/src/ansi-c/ansi-c$(LIBEXT) \
              $(CPROVER_DIR)/src/cpp/cpp$(LIBEXT) \
              $(CPROVER_DIR)/src/json/json$(LIBEXT) \
              $(CPROVER_DIR)/src/linking/linking$(LIBEXT) \
              $(CPROVER_DIR)/src/util/util$(LIBEXT) \
              $(CPROVER_DIR)/src/big-int/big-int$(LIBEXT) \
              $(CPROVER_DIR)/src/goto-programs/goto-programs$(LIBEXT) \
              $(CPROVER_DIR)/src/goto-instrument/goto-instrument$(LIBEXT) \
              $(CPROVER_DIR)/src/pointer-analysis/pointer-analysis$(LIBEXT) \
              $(CPROVER_DIR)/src/langapi/langapi$(LIBEXT) \
              $(CPROVER_DIR)/src/assembler/assembler$(LIBEXT) \
              $(CPROVER_DIR)/src/analyses/analyses$(LIBEXT) \
              $(CPROVER_DIR)/src/solvers/solvers$(LIBEXT) \
              $(BMC_DEPS) \
              # Empty last line

OBJ += $(CPROVER_LIBS) \
       $(CPROVER_DIR)/unit/testing-utils/testing-utils$(LIBEXT) \
       java-testing-utils/java-testing-utils$(LIBEXT)

TESTS = unit_tests$(EXEEXT) \
        # Empty last line

CLEANFILES = $(TESTS)

all: cprover.dir cprover-testing-utils.dir jprover.dir java-testing-utils.dir
	$(MAKE) $(MAKEARGS) $(TESTS)

test: all
	$(foreach test,$(TESTS), (echo Running: $(test); ./$(test)) &&) true


###############################################################################

unit_tests$(EXEEXT): $(OBJ)
	$(LINKBIN)

=== regression/cbmc/Makefile ===
default: tests.log

test:
	@../test.pl -p -c ../../../src/cbmc/cbmc -X smt-backend

tests.log: ../test.pl
	@../test.pl -p -c ../../../src/cbmc/cbmc -X smt-backend

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

clean:
	find -name '*.out' -execdir $(RM) '{}' \;
	find -name '*.gb' -execdir $(RM) '{}' \;
	$(RM) tests.log

=== regression/goto-gcc/Makefile ===
default: tests.log

test:
	-@ln -s goto-cc ../../src/goto-cc/goto-gcc
	@../test.pl -p -c ../../../src/goto-cc/goto-gcc

tests.log: ../test.pl
	-@ln -s goto-cc ../../src/goto-cc/goto-gcc
	@../test.pl -p -c ../../../src/goto-cc/goto-gcc

show:
	@for dir in *; do \
	  if [ -d "$$dir" ]; then \
	    vim -o "$$dir/*.c" "$$dir/*.out"; \
	  fi; \
	done;

clean:
	find -name '*.out' -execdir $(RM) '{}' \;
	find -name '*.gb' -execdir $(RM) '{}' \;
	$(RM) tests.log

=== regression/invariants/Makefile ===
default: tests.log

SRC = driver.cpp

INCLUDES = -I ../../src

OBJ += ../../src/big-int/big-int$(LIBEXT) \
      ../../src/util/util$(LIBEXT)

include ../../src/config.inc
include ../../src/common

test: driver$(EXEEXT)
	@../test.pl -p -c ../driver

tests.log: ../test.pl driver$(EXEEXT)
	@../test.pl -p -c ../driver

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

driver$(EXEEXT): $(OBJ)
	$(LINKBIN)

=== debian/changelog ===
cbmc (5.9-6) unstable; urgency=low

  * Fix mips 32-bit cross configuration
  * Fix Java string literal conversion for big-endian architectures

 -- Michael Tautschnig <mt@debian.org>  Thu, 05 Jul 2018 22:36:05 +0100

cbmc (5.9-5) unstable; urgency=low

  * Add support for goto-gcc on kfreebsd
  * Fix regression test for unsigned-char architectures

 -- Michael Tautschnig <mt@debian.org>  Wed, 04 Jul 2018 16:50:58 +0100

cbmc (5.9-4) unstable; urgency=low

  * Fix preprocessing flags for non-x86 architectures
  * Fix copy&paste error in built-in library
  * Fix endianness bugs in tests
  * Enable all hardening flags

 -- Michael Tautschnig <mt@debian.org>  Wed, 04 Jul 2018 10:53:33 +0100

cbmc (5.9-3) unstable; urgency=low

  * Make bitwidth preprocessor options architecture-specific

 -- Michael Tautschnig <mt@debian.org>  Tue, 03 Jul 2018 18:58:45 +0100

cbmc (5.9-2) unstable; urgency=low

  * Build-depends libc6-dev-i386 for amd64, x32

 -- Michael Tautschnig <mt@debian.org>  Tue, 03 Jul 2018 16:17:02 +0100

cbmc (5.9-1) unstable; urgency=low

  * New upstream release
    - Fixes FTBFS with new GCC due to uninitialized variables (Closes: #871068)

 -- Michael Tautschnig <mt@debian.org>  Mon, 02 Jul 2018 17:12:01 +0100

=== debian/control ===
Source: cbmc
Section: science
Priority: optional
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper (>= 10), minisat (>= 1:2.2.1-2), zlib1g-dev, flex,
 bison, openjdk-8-jdk-headless
Standards-Version: 4.1.5
Homepage: http://www.cprover.org/cbmc/

Package: cbmc
Architecture: any
Depends: gcc, ${shlibs:Depends}, ${misc:Depends}
Description: bounded model checker for C and C++ programs
 CBMC generates traces that demonstrate how an assertion can be violated, or
 proves that the assertion cannot be violated within a given number of loop
 iterations.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND := -Wall -O2 -g -Werror -Wno-parentheses -Wno-deprecated -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) -C src clean
	$(RM) src/goto-cc/goto-gcc
	$(MAKE) -C jbmc/src clean
	$(RM) -r jbmc/src/java_bytecode/library/src
	$(MAKE) -C regression clean
	$(MAKE) -C jbmc/regression clean
	$(RM) regression/cbmc/Malloc22/main.smt2
	$(RM) regression/goto-gcc/run_diagnostic/a.out.goto-cc-saved
	$(RM) regression/goto-gcc/expect_fail/a.out.goto-cc-saved
	$(RM) regression/invariants/driver
	$(RM) regression/invariants/tests.log
	$(RM) regression/invariants/invariant-failure*/test.out
	$(RM) jbmc/regression/jbmc-strings/tests-symex-driven-loading.log
	$(RM) jbmc/regression/jbmc/tests-symex-driven-loading.log

override_dh_auto_configure:
	cp -r java-models-library/src jbmc/src/java_bytecode/library

override_dh_auto_build:
	$(MAKE) -C src \
		MINISAT2=/usr/include/minisat \
		LINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS) \
		LIBSOLVER=-lminisat GIT_INFO=cbmc-5.9
	$(MAKE) -C jbmc/src \
		MINISAT2=/usr/include/minisat \
		LINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS) \
		LIBSOLVER=-lminisat GIT_INFO=cbmc-5.9

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C regression test
	$(MAKE) -C jbmc/regression test
endif

## cbmc 5.10

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
    message(STATUS "Rule launch compile: ${CCACHE_PROGRAM}")
 endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS true)

set(CMAKE_OSX_DEPLOYMENT_TARGET 10.9)

include(GNUInstallDirs)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
   "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang" OR
   "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU"
)
    #   Ensure NDEBUG is not set for release builds
    set(CMAKE_CXX_FLAGS_RELEASE "-O2")
    #   Enable lots of warnings
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wpedantic -Werror -Wno-deprecated-declarations")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    #   This would be the place to enable warnings for Windows builds, although
    #   config.inc doesn't seem to do that currently
endif()

set(enable_cbmc_tests on CACHE BOOL "Whether CBMC tests should be enabled")

set(sat_impl "minisat2" CACHE STRING
    "This setting controls the SAT library which is used. Valid values are 'minisat2' and 'glucose'"
)

if(${enable_cbmc_tests})
    enable_testing()
endif()

add_subdirectory(src)
add_subdirectory(regression)
add_subdirectory(unit)

add_subdirectory(jbmc)

set_target_properties(
    analyses
    ansi-c
    assembler
    big-int
    cbmc
    cbmc-lib
    clobber
    clobber-lib
    cpp
    driver
    goto-analyzer
    goto-analyzer-lib
    goto-cc
    goto-cc-lib
    goto-diff
    goto-diff-lib
    goto-instrument
    goto-instrument-lib
    goto-programs
    goto-symex
    jsil
    json
    langapi
    linking
    miniBDD
    mmcc
    pointer-analysis
    solvers
    test-bigint
    testing-utils
    unit
    util
    xml

    java_bytecode
    java-models-library
    jbmc
    jbmc-lib
    janalyzer
    janalyzer-lib
    jdiff
    jdiff-lib
    java-testing-utils
    java-unit
    miniz

    PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED true
    XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "Developer ID Application: Daniel Kroening"
)

=== Makefile ===
default: tests.log

testalpha:
	@../test.pl -c ../chain.sh -C

testbeta:
	@../test.pl -c ../chain.sh -T

testimpr:
	@../test.pl -c ../chain.sh -K

testnew:
	@../test.pl -c ../chain.sh -F

test:
	@../test.pl -c ../chain.sh 

tests.log: ../test.pl
	@../test.pl -c ../chain.sh 

clean:
	@for dir in *; do \
                if [ -d "$$dir" ]; then \
                        rm $$dir/*.txt $$dir/*.dot $$dir/*.gb $$dir/*.out; \
                fi; \
        done;

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

=== jbmc/CMakeLists.txt ===
add_subdirectory(regression)
add_subdirectory(src)
add_subdirectory(unit)

add_custom_target(java-models-library ALL
    COMMAND mvn package
    COMMAND cp target/core-models.jar ${CMAKE_CURRENT_SOURCE_DIR}/src/java_bytecode/library/
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/lib/java-models-library
)

=== regression/CMakeLists.txt ===
set(test_pl_path "${CMAKE_CURRENT_SOURCE_DIR}/test.pl")

macro(add_test_pl_profile name cmdline flag profile)
    add_test(
        NAME "${name}-${profile}"
        COMMAND ${test_pl_path} -p -c ${cmdline} ${flag} ${ARGN}
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    )
    set_tests_properties("${name}-${profile}" PROPERTIES
        LABELS "${profile};CBMC"
    )
endmacro(add_test_pl_profile)

macro(add_test_pl_tests cmdline)
    get_filename_component(TEST_DIR_NAME ${CMAKE_CURRENT_SOURCE_DIR} NAME)
    message(STATUS "Adding tests in directory: ${TEST_DIR_NAME}")
    add_test_pl_profile("${TEST_DIR_NAME}" "${cmdline}" -C CORE ${ARGN})
    add_test_pl_profile("${TEST_DIR_NAME}" "${cmdline}" -T THOROUGH ${ARGN})
    add_test_pl_profile("${TEST_DIR_NAME}" "${cmdline}" -F FUTURE ${ARGN})
    add_test_pl_profile("${TEST_DIR_NAME}" "${cmdline}" -K KNOWNBUG ${ARGN})
endmacro(add_test_pl_tests)

# For the best possible utilisation of multiple cores when
# running tests in parallel, it is important that these directories are
# listed with decreasing runtimes (i.e. longest running at the top)
add_subdirectory(cbmc)
add_subdirectory(goto-analyzer)
add_subdirectory(ansi-c)
add_subdirectory(goto-instrument)
add_subdirectory(cpp)
add_subdirectory(cbmc-cover)
add_subdirectory(goto-instrument-typedef)
add_subdirectory(smt2_solver)
add_subdirectory(strings)
add_subdirectory(invariants)
add_subdirectory(goto-diff)
add_subdirectory(test-script)
add_subdirectory(goto-analyzer-taint)
if(NOT WIN32)
  add_subdirectory(goto-gcc)
endif()
add_subdirectory(goto-cc-cbmc)
add_subdirectory(cbmc-cpp)
add_subdirectory(goto-cc-goto-analyzer)
add_subdirectory(systemc)

=== regression/Makefile ===
# For the best possible utilisation of multiple cores when
# running tests in parallel, it is important that these directories are
# listed with decreasing runtimes (i.e. longest running at the top)
DIRS = cbmc \
       goto-analyzer \
       ansi-c \
       goto-instrument \
       cpp \
       cbmc-cover \
       goto-instrument-typedef \
       smt2_solver \
       strings \
       invariants \
       goto-diff \
       test-script \
       goto-analyzer-taint \
       goto-gcc \
       goto-cc-cbmc \
       cbmc-cpp \
       goto-cc-goto-analyzer \
       systemc \
       contracts \
       # Empty last line

# Tests under goto-gcc cannot be run on Windows, so appveyor.yml unlinks
# the entire directory under Windows. This variable will contain the list
# of directories that actually exist on the current platform.
PLATFORM_DIRS = $(wildcard $(DIRS))

# Run all test directories in sequence
.PHONY: test
test:
	@for dir in $(PLATFORM_DIRS); do \
		$(MAKE) "$$dir" || exit 1; \
	done;

# Pattern to execute a single test suite directory
.PHONY: $(PLATFORM_DIRS)
$(PLATFORM_DIRS):
	@echo "Running $@..." ;
	$(MAKE) -C "$@" test || exit 1;

# Run all test directories using GNU Parallel
.PHONY: test-parallel
.NOTPARALLEL: test-parallel
test-parallel:
	@echo "Building with $(JOBS) jobs"
	parallel \
		--halt soon,fail=1 \
		--tag \
		--tagstring '{#}:' \
		--linebuffer \
		--jobs $(JOBS) \
		$(MAKE) "{}" \
		::: $(PLATFORM_DIRS)


.PHONY: clean
clean:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			$(MAKE) -C "$$dir" clean; \
		fi; \
	done;

=== src/CMakeLists.txt ===
project(CBMC)

find_package(BISON)
find_package(FLEX)

find_package(Doxygen)
if(DOXYGEN_FOUND)
    add_custom_target(doc
        "${DOXYGEN_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/doxygen.cfg"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    )
endif(DOXYGEN_FOUND)

#   Add a bison target named 'parser'.
macro(generic_bison name)
    set(bison_header "${name}_y.tab.h")
    if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${bison_header}")
        message(FATAL_ERROR "Generated file ${bison_header} found in source tree. If you previously built with `make`, run `make clean` and try again")
    endif()

    set(bison_source "${name}_y.tab.cpp")
    if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${bison_source}")
        message(FATAL_ERROR "Generated file ${bison_source} found in source tree. If you previously built with `make`, run `make clean` and try again")
    endif()

    bison_target(
        parser
        "${CMAKE_CURRENT_SOURCE_DIR}/parser.y"
        "${CMAKE_CURRENT_BINARY_DIR}/${bison_source}"
        COMPILE_FLAGS "-pyy${name}"
    )
    set(renamed_parser_header "${CMAKE_CURRENT_BINARY_DIR}/${bison_header}")
    add_custom_command(OUTPUT "${renamed_parser_header}"
        COMMAND "${CMAKE_COMMAND}" -E copy "${BISON_parser_OUTPUT_HEADER}" "${renamed_parser_header}"
        MAIN_DEPENDENCY "${BISON_parser_OUTPUT_HEADER}"
    )
    list(REMOVE_ITEM BISON_parser_OUTPUTS "${BISON_parser_OUTPUT_HEADER}")
    list(APPEND BISON_parser_OUTPUTS "${renamed_parser_header}")
endmacro(generic_bison)

#   Add a flex target named 'scanner'
macro(generic_flex name)
    set(flex_source "${name}_lex.yy.cpp")
    if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${flex_source}")
        message(FATAL_ERROR "Generated file ${flex_source} found in source tree. If you previously built with `make`, run `make clean` and try again")
    endif()

    flex_target(
        scanner
        "${CMAKE_CURRENT_SOURCE_DIR}/scanner.l"
        "${CMAKE_CURRENT_BINARY_DIR}/${name}_lex.yy.cpp"
        COMPILE_FLAGS "-Pyy${name}"
    )
endmacro(generic_flex)

#   Set the public include locations for a target.
macro(generic_includes name)
    target_include_directories(${name}
        PUBLIC
        ${CBMC_BINARY_DIR}
        ${CBMC_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
    )
endmacro(generic_includes)

#   Link optional modules.
#   Target is the name of the target with optional components.
#   Name is the name of the optional target.
#   Also adds a compile flag signalling to the preprocessor that the library is
#   used.
macro(add_if_library target name)
    if(TARGET ${name})
        target_link_libraries(${target} ${name})

        string(TOUPPER ${name} upper_name)
        string(REGEX REPLACE "-" "_" define ${upper_name})

        target_compile_definitions(${target} PUBLIC HAVE_${define})
    endif()
endmacro(add_if_library)

add_subdirectory(analyses)
add_subdirectory(ansi-c)
add_subdirectory(assembler)
add_subdirectory(big-int)
add_subdirectory(cpp)
add_subdirectory(goto-programs)
add_subdirectory(goto-symex)
add_subdirectory(jsil)
add_subdirectory(json)
add_subdirectory(langapi)
add_subdirectory(linking)
add_subdirectory(memory-models)
add_subdirectory(pointer-analysis)
add_subdirectory(solvers)
add_subdirectory(util)
add_subdirectory(xmllang)
add_subdirectory(clobber)

add_subdirectory(cbmc)
add_subdirectory(goto-cc)
add_subdirectory(goto-instrument)
add_subdirectory(goto-analyzer)
add_subdirectory(goto-diff)

=== src/Makefile ===
DIRS = analyses \
       ansi-c \
       assembler \
       big-int \
       cbmc \
       clobber \
       cpp \
       goto-analyzer \
       goto-cc \
       goto-diff \
       goto-instrument \
       goto-programs \
       goto-symex \
       jsil \
       json \
       langapi \
       linking \
       memory-models \
       pointer-analysis \
       solvers \
       util \
       xmllang \
       # Empty last line

all: cbmc.dir \
     goto-analyzer.dir \
     goto-cc.dir \
     goto-diff.dir \
     goto-instrument.dir \
     # Empty last line

###############################################################################

util.dir: big-int.dir

# everything but big-int depends on util
$(patsubst %, %.dir, $(filter-out big-int util, $(DIRS))): util.dir

.PHONY: languages
.PHONY: clean

cpp.dir: ansi-c.dir linking.dir

languages: util.dir langapi.dir \
           cpp.dir ansi-c.dir xmllang.dir assembler.dir \
           jsil.dir

solvers.dir: util.dir langapi.dir

goto-instrument.dir: languages goto-programs.dir pointer-analysis.dir \
                     goto-symex.dir linking.dir analyses.dir solvers.dir \
                     json.dir

cbmc.dir: languages solvers.dir goto-symex.dir analyses.dir \
          pointer-analysis.dir goto-programs.dir linking.dir \
          goto-instrument.dir

goto-analyzer.dir: languages analyses.dir goto-programs.dir linking.dir \
                   json.dir goto-instrument.dir

goto-diff.dir: languages goto-programs.dir pointer-analysis.dir \
               linking.dir analyses.dir goto-instrument.dir \
               solvers.dir json.dir goto-symex.dir

goto-cc.dir: languages pointer-analysis.dir goto-programs.dir linking.dir

# building for a particular directory

$(patsubst %, %.dir, $(DIRS)):
	## Entering $(basename $@)
	$(MAKE) $(MAKEARGS) -C $(basename $@)

# generate source files

$(patsubst %, %_generated_files, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_generated_files, %, $@) generated_files

generated_files: $(patsubst %, %_generated_files, $(DIRS))

# cleaning

clean: $(patsubst %, %_clean, $(DIRS))

$(patsubst %, %_clean, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_clean, %, $@) clean ; \

# minisat2 and glucose download, for your convenience

DOWNLOADER = lwp-download
TAR = tar

minisat2-download:
	@echo "Downloading Minisat 2.2.1"
	@$(DOWNLOADER) http://ftp.debian.org/debian/pool/main/m/minisat2/minisat2_2.2.1.orig.tar.gz
	@$(TAR) xfz minisat2_2.2.1.orig.tar.gz
	@rm -Rf ../minisat-2.2.1
	@mv minisat2-2.2.1 ../minisat-2.2.1
	@(cd ../minisat-2.2.1; patch -p1 < ../scripts/minisat-2.2.1-patch)
	@rm minisat2_2.2.1.orig.tar.gz

glucose-download:
	@echo "Downloading glucose-syrup"
	@$(DOWNLOADER) http://www.labri.fr/perso/lsimon/downloads/softwares/glucose-syrup.tgz
	@$(TAR) xfz glucose-syrup.tgz
	@rm -Rf ../glucose-syrup
	@mv glucose-syrup ../
	@(cd ../glucose-syrup; patch -p1 < ../scripts/glucose-syrup-patch)
	@rm glucose-syrup.tgz

ipasir-download:
	# get the 2016 version of the ipasir package, which contains a few solvers
	@echo "Download ipasir 2016 package"
	@(lwp-download http://baldur.iti.kit.edu/sat-competition-2016/downloads/ipasir.zip ../ipasir.zip)
	@(cd ..; unzip -u ipasir.zip)

ipasir-build: ipasir-download
	# build libpicosat, and create a libipasir.a in ipasir directory
	# make sure that the ipasir.h file is located there as well (ships with 2016 package)
	@echo "Build Picosat 961 from ipasir 2016 package"
	$(MAKE) -C ../ipasir/sat/picosat961 libipasirpicosat961.a
	@(cd ../ipasir; ln -sf sat/picosat961/libipasirpicosat961.a libipasir.a)

cadical_release = rel-06w
cadical-download:
	@echo "Downloading CaDiCaL $(cadical_release)"
	@curl -L https://github.com/arminbiere/cadical/archive/$(cadical_release).tar.gz | tar xz
	@rm -Rf ../cadical
	@mv cadical-$(cadical_release) ../cadical
	@(cd ../cadical; patch -p1 < ../scripts/cadical-patch)
	@cd ../cadical && CXX=$(CXX) CXXFLAGS=-O3 ./configure --debug && make

doc :
	doxygen

.PHONY: ipasir-build minisat2-download glucose-download

=== unit/CMakeLists.txt ===
--- 
+++ 
@@ -7,16 +7,13 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/miniBDD.cpp
 
     # Don't build
-    ${CMAKE_CURRENT_SOURCE_DIR}/sharing_map.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/elf_reader.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/smt2_parser.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/json.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/cpp_parser.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/osx_fat_reader.cpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/unicode.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/wp.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/cpp_scanner.cpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/float_utils.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/ieee_float.cpp
 
     # Will be built into a separate library and linked

=== unit/Makefile ===
--- 
+++ 
@@ -7,13 +7,17 @@
 
 # Test source files
 SRC += unit_tests.cpp \
+       analyses/ai/ai.cpp \
        analyses/ai/ai_simplify_lhs.cpp \
        analyses/call_graph.cpp \
+       analyses/constant_propagator.cpp \
+       analyses/disconnect_unreachable_nodes_in_graph.cpp \
        analyses/does_remove_const/does_expr_lose_const.cpp \
        analyses/does_remove_const/does_type_preserve_const_correctness.cpp \
        analyses/does_remove_const/is_type_at_least_as_const_as.cpp \
        goto-programs/goto_trace_output.cpp \
        path_strategies.cpp \
+       solvers/floatbv/float_utils.cpp \
        solvers/refinement/array_pool/array_pool.cpp \
        solvers/refinement/string_constraint_generator_valueof/calculate_max_string_length.cpp \
        solvers/refinement/string_constraint_generator_valueof/get_numeric_value_from_character.cpp \
@@ -22,7 +26,11 @@
        solvers/refinement/string_refinement/substitute_array_list.cpp \
        solvers/refinement/string_refinement/sparse_array.cpp \
        solvers/refinement/string_refinement/union_find_replace.cpp \
+       util/expr.cpp \
        util/expr_cast/expr_cast.cpp \
+       util/file_util.cpp \
+       util/get_base_name.cpp \
+       util/graph.cpp \
        util/irep.cpp \
        util/irep_sharing.cpp \
        util/message.cpp \
@@ -34,6 +42,7 @@
        util/string_utils/split_string.cpp \
        util/string_utils/strip_string.cpp \
        util/symbol_table.cpp \
+       util/unicode.cpp \
        catch_example.cpp \
        # Empty last line

=== jbmc/regression/CMakeLists.txt ===
--- 
+++ 
@@ -11,3 +11,4 @@
 add_subdirectory(jbmc-concurrency)
 add_subdirectory(jbmc-inheritance)
 add_subdirectory(jbmc-cover)
+add_subdirectory(jbmc-generics)

=== jbmc/regression/Makefile ===
# For the best possible utilisation of multiple cores when
# running tests in parallel, it is important that these directories are
# listed with decreasing runtimes (i.e. longest running at the top)
DIRS = janalyzer-taint \
       jbmc \
       jbmc-concurrency \
       jbmc-cover \
       jbmc-inheritance \
       jbmc-strings \
       jdiff \
       strings-smoke-tests \
       jbmc-generics \
       # Empty last line

# Run all test directories in sequence
.PHONY: test
test:
	@for dir in $(DIRS); do \
		$(MAKE) "$$dir" || exit 1; \
	done;

# Pattern to execute a single test suite directory
.PHONY: $(DIRS)
$(DIRS):
	@echo "Running $@..." ;
	$(MAKE) -C "$@" test || exit 1;

# Run all test directories using GNU Parallel
.PHONY: test-parallel
.NOTPARALLEL: test-parallel
test-parallel:
	@echo "Building with $(JOBS) jobs"
	parallel \
		--halt soon,fail=1 \
		--tag \
		--tagstring '{#}:' \
		--linebuffer \
		--jobs $(JOBS) \
		$(MAKE) "{}" \
		::: $(DIRS)


.PHONY: clean
clean:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			$(MAKE) -C "$$dir" clean; \
		fi; \
	done;

=== jbmc/src/CMakeLists.txt ===
project(JBMC)

#   Set the public include locations for a target.
macro(generic_includes name)
    target_include_directories(${name}
        PUBLIC
        ${JBMC_BINARY_DIR}
        ${JBMC_SOURCE_DIR}
        ${CBMC_BINARY_DIR}
        ${CBMC_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
    )
endmacro(generic_includes)

add_subdirectory(miniz)
add_subdirectory(java_bytecode)
add_subdirectory(jbmc)
add_subdirectory(janalyzer)
add_subdirectory(jdiff)

=== debian/changelog ===
cbmc (5.10-5ubuntu1) focal; urgency=medium

  [ Adrian Bunk ]
  * Build fixes:
    - Fix the build with libmaven-compiler-plugin-java 3.8.1.
    - Backport upstream fix for building with new bison.
    (Closes: #952256)

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 14 Apr 2020 07:35:50 +0000

cbmc (5.10-5build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:11:11 +0100

cbmc (5.10-5) unstable; urgency=low

  * Use default-jdk-headless instead of openjdk-8 (Closes: #910704)

 -- Michael Tautschnig <mt@debian.org>  Wed, 17 Oct 2018 19:55:17 +0100

cbmc (5.10-4) unstable; urgency=low

  * Mark java_append_char test as THOROUGH as it requires more memory than
    available on some buildds.
  * Fix-up __float128 patch for ppc64 and powerpc.

 -- Michael Tautschnig <mt@debian.org>  Mon, 01 Oct 2018 08:00:38 +0100

cbmc (5.10-3) unstable; urgency=low

  * Fix regression tests using __float128, which is not available on all
    architectures.

 -- Michael Tautschnig <mt@debian.org>  Sun, 30 Sep 2018 18:29:38 +0100

cbmc (5.10-2) unstable; urgency=low

  * Fix regression tests using __float80, which is x86 only (Closes: #909932)

 -- Michael Tautschnig <mt@debian.org>  Sun, 30 Sep 2018 15:08:10 +0100

cbmc (5.10-1) unstable; urgency=low

  * New upstream release
  * Updated Standards version to 4.2.1 (no changes required)

 -- Michael Tautschnig <mt@debian.org>  Thu, 27 Sep 2018 10:18:47 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,13 @@
 Source: cbmc
 Section: science
 Priority: optional
-Maintainer: Michael Tautschnig <mt@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Michael Tautschnig <mt@debian.org>
 Build-Depends: debhelper (>= 10), minisat (>= 1:2.2.1-2), zlib1g-dev, flex,
- bison, openjdk-8-jdk-headless
-Standards-Version: 4.1.5
+ bison, default-jdk-headless, maven, maven-repo-helper, maven-debian-helper,
+ libmaven-compiler-plugin-java (>= 3.8.1),
+ libmaven-compiler-plugin-java (<< 3.8.2~)
+Standards-Version: 4.2.1
 Homepage: http://www.cprover.org/cbmc/
 
 Package: cbmc

=== debian/rules ===
--- 
+++ 
@@ -21,30 +21,25 @@
 	$(MAKE) -C src clean
 	$(RM) src/goto-cc/goto-gcc
 	$(MAKE) -C jbmc/src clean
-	$(RM) -r jbmc/src/java_bytecode/library/src
+	$(RM) -r jbmc/lib
 	$(MAKE) -C regression clean
 	$(MAKE) -C jbmc/regression clean
-	$(RM) regression/cbmc/Malloc22/main.smt2
-	$(RM) regression/goto-gcc/run_diagnostic/a.out.goto-cc-saved
-	$(RM) regression/goto-gcc/expect_fail/a.out.goto-cc-saved
-	$(RM) regression/invariants/driver
-	$(RM) regression/invariants/tests.log
-	$(RM) regression/invariants/invariant-failure*/test.out
-	$(RM) jbmc/regression/jbmc-strings/tests-symex-driven-loading.log
-	$(RM) jbmc/regression/jbmc/tests-symex-driven-loading.log
+	$(RM) jbmc/regression/jbmc-generics/tests-symex-driven-loading.log
+	$(RM) jbmc/regression/strings-smoke-tests/tests-symex-driven-loading.log
 
 override_dh_auto_configure:
-	cp -r java-models-library/src jbmc/src/java_bytecode/library
+	mkdir jbmc/lib
+	cp -r java-models-library jbmc/lib/
 
 override_dh_auto_build:
 	$(MAKE) -C src \
 		MINISAT2=/usr/include/minisat \
 		LINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS) \
-		LIBSOLVER=-lminisat GIT_INFO=cbmc-5.9
+		LIBS=-lminisat GIT_INFO=cbmc-5.10
 	$(MAKE) -C jbmc/src \
 		MINISAT2=/usr/include/minisat \
 		LINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS) \
-		LIBSOLVER=-lminisat GIT_INFO=cbmc-5.9
+		LIBS=-lminisat GIT_INFO=cbmc-5.10
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
